//Lauflicht 
// mit Richtungsaenderungsmoeglichkeit
// ueber Jumper zwischen PB1, PB2, PB3 und Masse
// LEDs an PA0..PA7
// 24.05.2012

#include "HT46F47E.h"

#pragma vector isr_4 @ 0x4
#pragma vector isr_8 @ 0x8
#pragma vector isr_c @ 0xc

//ISR for safequard
void isr_4(){} // external ISR
void isr_8(){} // timer/event 0
void isr_c(){} // timer/event 1

//initialize registers for safeguard
void safeguard_init(){
	_intc = 0;
	_tmrc = 0;
	_tmr = 0;
	_pac = 0xff; //input mode
	_pbc = 0xff;

}


unsigned char u,n,pb;

void mydelay(unsigned int times){
	while(times--)	_delay(65000);
}

void Linkslauf()
{
	_pa=0b10000000;
 			 mydelay(u);
 			for(n=0;n<7;n++)
 			 {
 			 _pa=_pa>>1;
 			 mydelay(u);
 			 }
 			 _pa=0b00000000;
 			 mydelay(u);
}

void Rechtslauf()
{
	_pa=0b00000001;
 			 mydelay(u);
 			for(n=0;n<7;n++)
 			 {
 			 _pa=_pa<<1;
 			 mydelay(u);
 			 }
 			 _pa=0b00000000;
 			 mydelay(u);
} 			 
 			 
void Blink1()
{
	_pa=0b10101010;
	mydelay(u);
	_pa=0b01010101;
	mydelay(u);
}

void Blink2()
{
	_pa=0b11110000;
	mydelay(u);
	_pa=0b00001111;
	mydelay(u);
}
void main(){
	
	safeguard_init();
    
	_pac = 0; //set port A to output port
	_pa = 0; //zero port A (all light on)
	_eadi = 0;     //Kein Interupt
	_acsr = 1;    //AD-Clock = 1/8
	
	
	while (1)
	{
		
_adcr = 8;      //nur B0 als ADC0, AdC0 gewaehlt
			_start=0;
			_start=1;       //AD-Start
			_start=0;
 			while (_eocb == 1);
 			u = _adrh;     //Aufloesung 8 Bit
 			u=255-u;
 			u=(u>>4);
 			// Der Wert von u bestimmt ueber mydelay(u)
 			// jeweils die Einschaltzeit.
            pb = (_pb >> 1) & 7;
            if (pb == 7)
            {
            Blink1();
            }
            if (pb == 6) 
            {			
 			Rechtslauf();
 			}
 			if (pb == 5) 
 			{ 
			Linkslauf(); 
        	}
        	if (pb == 3) 
 			{ 
			Blink2(); 
        	}
}
}			
